! SUBROUTINE AXENER ====*====3====*====4====*====5====*====6====*====7
!
! NSPIN: paramagnetic case ( both 'with spin orbit' and ' without spin-orbit' ! ... NSPIN=0
!        magnetic case  ...  NSPIN=1 ONLY FOR UP   SPIN BANDS'
!                       ...  NSPIN=2 ONLY FOR DOWN SPIN BANDS'
!                       ...  NSPIN=3 FOR BOTH SPIN BANDS
!
! JDOUB: single representaion ... 0 ( without Spin-Orbit Interaction )
!      : double representaion ... 1 ( with    Spin-Orbit Interaction )
!
!  modified by H.Funashima,2010
!     remove argument ipr ( ipr in  module::scl instead of argument )
!
!
!---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      SUBROUTINE AXENER(JDOUB,NSPIN)
      use scl, only:ipr
      use axe, only:jud,naxen
      use isp, only:naxm
      use kkend 
      use check_array_size, only:check_naxen
      implicit none
!
      integer :: jdoub
      integer :: nspin

      integer :: KB(3),JTR(12),IPA(12),ND(12)
      integer :: NRECPT(3,20)
      integer :: IC,JD,IUD,NRPT
      integer :: NR,NH, NSTR, MTR
      integer :: i,ir,Iaxis,k

      JD=JDOUB
      NAXEN=0
      DO 11 Iaxis=1,NAXM
         IF(IPR.GE.2) WRITE(6,601) Iaxis
  601    FORMAT(' RECFND for Axis No.',I3)
         CALL RECFND(Iaxis,NRECPT,NRPT)
         IF(IPR.GE.2) WRITE(6,602) NRPT
  602    FORMAT(' KPFIEN... number of reciprocal lattice points =',I3)
         CALL KPFIEN(Iaxis,NRECPT,NRPT,IPR)

         !
         ! ( KB(1), KB(2), KB(3) ) / IC : middle-point on the Iaxis th axis
         !
         !    (  KKM(1,1,Iaxis), KKM(1,2,Iaxis), KKM(1,3,Iaxis) ) /   ICCM(1,Iaxis) : starting k-point at Iaxis th axis
         !    (  KKM(2,1,Iaxis), KKM(2,2,Iaxis), KKM(2,3,Iaxis) ) /   ICCM(2,Iaxis) : end      k-point at Iaxis th axis
         !

         do K=1,3
            KB(K)=KKM(1,K,Iaxis)*ICCM(2,Iaxis)+KKM(2,K,Iaxis)*ICCM(1,Iaxis)
         enddo
         IC=ICCM(1,Iaxis)*ICCM(2,Iaxis)*2

         !-------------------------------------------------------------
         !
         ! obtain small representation using tspace
         !
         !-------------------------------------------------------------
         CALL TSIREP(KB,IC,JD)

         !-------------------------------------------------------------
         !
         ! == Specification Subroutine DGTRMD(in TSPACE) ===
         !
         ! -- input --
         !  JD=0 (single group)
         !  JD=1 (double group)
         !
         ! -- output --
         !  NR     : Number of Irreducible Representation
         !  NH     : Number of Elements of K-point Group
         !  NSTR   : Number of Star
         !  ND     : Deneracy of Irreducible Represenation
         !  MTR    : Number of Time Reversal Element
         !  JTR(12): Herring Sum
         !  IPA(12): Partner
         !
         !
         ! modified by H.Funashima,2011
         !   bug fixed by H.Funashima, 2011: JDO -> JD call sub. DGTRMD
         !
         !-------------------------------------------------------------
         CALL DGTRMD(JD,NR,NH,NSTR,ND,MTR,JTR,IPA)
         
         IF(IPR.GE.2) WRITE(6,603) KB,IC
  603    FORMAT(' CMPTBL (',3I3,')/',I4)
         CALL CMPTBL(JD,KB,IC,NR,NH,MTR)   
         do IR=1,NR
            IF(JTR(IR).EQ.0.AND.IPA(IR).LT.IR) cycle
            NAXEN=NAXEN+1
            call check_naxen ! check : naxen > maxirp ?
            IF(NSPIN.EQ.2) then
                IUD=2 
            else
                IUD=1
            endif
            CALL INTPOR(Iaxis,KB,IC,IR,IUD)
            JUD(NAXEN)=IUD
            IF(NSPIN.EQ.3) THEN
               NAXEN=NAXEN+1
               call check_naxen ! check : naxen > maxirp ?
               IUD=2
               CALL INTPOR(Iaxis,KB,IC,IR,IUD)
               JUD(NAXEN)=IUD
            END IF
         enddo
      write(6,*)
   11 CONTINUE
      RETURN
      end subroutine axener
