!************************************************************************
! AYBAND bandplot program using tspace                                  *
!                                                                       *
!      BAND PLOT PROGRAM (bandplt)                                      *
!               PROGRAMMED BY H.HARIMA                                  *
!       SPIN FERRO TAIOU  1989/10/30                                    *
!               MODIFIED BY A.YANASE                                    *
!                         1994/02/10                                    *
!     MODIFIED BY A.YANASE 2001/01/22                                   *
!         FOR AYPLOT SYSTEM                                             *
!     MODIFIED BY H.KONO (TOHOKU UNIV.)                                 *
!         AND     H.FUNASHIMA 2002/10/29                                *
!                    (SUBROUTINE PLOTSC, call cwrite and call kpname)   *
!     MODIFIED BY H.FUNASHIMA 2004/04/12                                *
!        FOR linetype(JOPT.ne.1)                                        *
!                                                                       *
!     MODIFIED BY H.FUNASHIMA 2009/08/21                                *
!        FORTRAN77 -> Fortran90                                         *
!                                                                       *
!     01:SPACE GROUP AND LATTICE CONSTANTS                              *
!     02:ENERGY OUTPUT FILE                                             *
!     03:FORMAT FILE                                                    *
!     IFILE:PS-file by AYPLOT                                           *
!                                                                       *
!************************************************************************
      program ayband
      use scl, only:IPR,ISO
      use ayband_param, only:maxeig,maxkpt,maxfkp,maxirp
      use check_array_size, only:set_initial_params
      use canvas
      use ayplot2, only:aypstr,ayorig,aypend,linewd,setdas
      implicit none
      character(40) ::  D
      integer :: JD,IUD
      integer :: JMARK
      integer :: NSPIN,NLCOMP
      integer :: jf 
      real(8) :: EF
!
! initial set.
!
      maxeig=4
      maxkpt=4
      maxfkp=4
      maxirp=4
      call set_initial_params
!
      write(6,*)'*===============* WELCOME TO AYBAND(ver.2.6) *===============*'
 3000 FORMAT('-----------------------------------------------------')
!
      WRITE(6,*)'Preparation to Call TSPACE....'
      WRITE(6,*)
      jf=1
      CALL TSPPRP(jf)
      WRITE(6,*) ' END OF TSPPRP'
      WRITE(6,3000)

      CALL TSVECT
      WRITE(6,*)'END OF TSVECT'
      WRITE(6,3000)
!
      jf=3
      CALL STRUCT(jf,NLCOMP,NSPIN,JMARK)
      WRITE(6,*) ' END OF STRUCT'
      WRITE(6,3000)
      write(6,*) 'jmark=',jmark
!

      WRITE(6,*)'Start to Read Energy....'
      !
      ! dispersion datafile number : jf
      !
      jf=2
      CALL ENERED(jf,NLCOMP)
      WRITE(6,*) ' END OF ENERED'
      WRITE(6,3000)

      !------------------------------------
      !
      ! JD: 0...Single Representaition 
      !     1...double Representaition 
      !
      !------------------------------------
      IF(ISO.EQ.3) then
          JD=1
      else
          JD=0
      endif

      WRITE(6,*)'>>>>>>> AXENER:'
      WRITE(6,*)
      CALL AXENER(JD,NSPIN)
      WRITE(6,*) ' END OF AXENR' 
      WRITE(6,3000)
!
      IF((IFILE.EQ.1).or.(IFILE.EQ.2)) THEN
      WRITE(6,3700)IFILE
 3700 format('You cannot use your IFILE number =',I3)
      STOP
      END IF
!
      WRITE(6,*)'== Prepare to set environment for ayplot library =='
      write(6,3600)IFILE
 3600 format('OUTPUT PostScript file nubmer= ',I3)
      CALL AYPSTR(IFILE)
      CALL AYORIG(50.0d0,40.0d0)
      CALL LINEWD(1.2d0)
!
      WRITE(6,3000)
      WRITE(6,*)'>>>>>>>  PLOT SCALES AND FLAMES START:'
      WRITE(6,*)
      CALL PLOTR
      write(6,*) ' END OF PLOTR'
      WRITE(6,3000)
!
      IF(NSPIN.EQ.2) then
          IUD=2
      else
          IUD=1
      endif
      CALL LINEWD(1.1d0)
!
      WRITE(6,*)'>>>>>>>  PLOT BAND START:'
      WRITE(6,*)
      CALL PLOTSC(IUD)
      IF(JMARK.EQ.1) then
          CALL MARKPL(IUD,NSPIN)
      else IF(JMARK.EQ.2) then
          CALL MARKCN(IUD,NSPIN)
      endif
      IF(NSPIN.EQ.3) THEN
         CALL LINEWD(0.9d0)
         CALL SETDAS(6,4,0)
         CALL PLOTSC(2)
         IF(JMARK.EQ.1) THEN
             CALL MARKPL(2,NSPIN)
         ELSE IF(JMARK.EQ.2) then
             CALL MARKCN(2,NSPIN)
         ENDIF
      END IF

      write(6,*) ' END OF PLOTSC'
      WRITE(6,3000)
      CALL LINEWD(2.0d0)
      READ(3,*,END=10)EF
   20 CALL LINEWD(1.2d0)
      WRITE(6,*)'>>>>>>>  PLOT FERMI ENERGY START:'
      WRITE(6,*)
      CALL FERMIE(EF)
      WRITE(6,620)EF
 620  FORMAT('Fermi Energy=',F8.4,' (Ry.)')
      write(6,*) ' END OF FERMIE'
      WRITE(6,3000)
   30 READ(3,'(A40)',err=10)D
      WRITE(6,*)'>>>>>>>  WRITE TITLE START:'
      CALL TITLE(D,25)
      write(6,*)
      write(6,'("Title: ",A40)')D
      WRITE(6,*) ' END OF TITLE'
      WRITE(6,3000)
   10 CALL AYPEND
      write(6,3500)IFILE
 3500 format('=== Ayband has finished to draw on fort.',I3,' ===')
      STOP
      END program ayband
