!**********************************************************************
!                                                                     *
! BRZONE : plot brilloiun zone and axis                               *
!                                                                     *
! $id v 6.0.1-ayame                                                   *
!                                                                     *
!     BRILLOUIN ZONE PLOT PROGRAM                                     *
!                  PROGRAMED BY A.YANASE                              *
!          Akira YANASE                                               *
!            Dept.Cond.Matt.Phys., ISIR, Osaka Univ.                  *
!            Email: yanase@cmp.sanken.osaka-u.ac.jp                   *
!                                                                     *
!     modified By H.Funashima,2002-2006                               *
!        to use angle.data                                            *
!          Hiroki FUNASHIMA                                           *
!            Dept.Cond.Matt.Phys., ISIR, Osaka Univ.                  *
!            Email: funa@cmp.sanken.osaka-u.ac.jp                     *
!                                                                     *
!                                                                     *
!     modified By H.Funashima,2003                                    *
!      for duble-precision syntax error                               *
!                                                                     *
!     modified By H.Funashima,8.Apr.2006                              *
!       to use TSPPRP and new subroutine change_angle                 *
!                                                                     *
!         Hiroki Funashima                                            *
!                                                                     *
!          Dept.Phys., Faculty of Engn. and Tech.,                    *
!          Tokyo Univ. of Sci.                                        *
!          Email:funa@ph.noda.tus.ac.jp                               *
!                                                                     *
!**********************************************************************
      use ayplot2, only:aypstr,ayorig,aypend,linewd
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION NRECPT(3,30),RECTAX(4,30),CO(3,2,100)
      DIMENSION JB(2,3)
      REAL*8 XFU(3,2),WF(3)
      DATA WF/160.0,160.0,160.0/
!
      write(6,*)'*===============* WELCOME TO BRZONE *===============*'
 3000 FORMAT('-----------------------------------------------------')
!
      WRITE(6,*)'Preparation to Call TSPACE....'
      WRITE(6,*)
      jf=1
      CALL TSPPRP(jf)
      WRITE(6,*) ' END OF TSPPRP'
      WRITE(6,3000)
      CALL change_angle(AF,BT,GM,ED,EL)
      jf=3
      CALL STRUCT(jf,NLCOMP,NSPIN,JMARK)
      WRITE(6,*) ' END OF STRUCT'
      WRITE(6,3000)
      !call linewd(0.5d0)
      CALL TSBZEG(NRECPT,RECTAX,NRP,CO,NLIN)
      XMAX=0.0
      XMIN=0.0
      DO 41 I=1,NLIN
      DO 41 J=1,2
      DO 41 K=1,3
        IF(XMAX.LT.CO(K,J,I)) XMAX=CO(K,J,I)
        IF(XMIN.GT.CO(K,J,I)) XMIN=CO(K,J,I)
 41   CONTINUE
      XMAX=XMAX*1.3D0
      XMIN=XMIN*1.3D0
      do K=1,3
        XFU(K,1)=XMIN
        XFU(K,2)=XMAX
      enddo
!
      OPEN(61,FILE='brzone.ps',ACCESS='sequential')
!
      CALL AYPSTR(61)
      CALL AYORIG(5.0d0,10.0d0)
      CALL TPERSP(XFU,WF,AF,BT,GM,ED,EL)
      CALL TPTRAC(1)   
      CALL TPHILP(-1.0D0)
      CALL TPHILD(0.0d0,1,6,5,0)
      CALL LINEWD(0.5d0)
      DO 42 I=1,NLIN
      X1=CO(1,1,I)
      Y1=CO(2,1,I)
      Z1=CO(3,1,I)
      X2=CO(1,2,I)
      Y2=CO(2,2,I)
      Z2=CO(3,2,I)
      CALL TPLINE(X1,Y1,Z1,X2,Y2,Z2,80)
   42 CONTINUE
      CALL TPCIHL(5)
      CALL AXISPL
      CALL AYPEND
      STOP
      END
