! SUBROUTINE DRCGCF ====*====3====*====4====*====5====*====6====*====7
!
! Direct transition Clebsch-Gordon Coeffcient  
!  
!
!---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      SUBROUTINE DRCGCF(JR1,JRG,JR2,DB,NI)
      implicit none

!------------------------------------------------------------------------------------
!
!   For TSPACE
!
      integer :: IL,NG,IG,JV ! for SPG2
      integer :: KB,ICB,MG,JG,JK,IZ,IFA,IFC,IDOUB,MTRG,JTRG,ITRC !for SPG3
      integer :: NR,NH,ND,IR,IATR ! for SPG4
      complex(8) :: CR ! for SPG4

      COMMON/SPG2/IL,NG,IG(48),JV(2,3,48)
      COMMON/SPG3/KB(3),ICB,MG,JG(48),JK(3,48)&
         ,IZ,IFA(48,48),IFC,IDOUB,MTRG,JTRG(4,48),ITRC(3,48)
      COMMON/SPG4/NR,NH,ND(12),IR(7,48,12),CR(48,12),IATR(12)
!
      save /SPG2/, /SPG3/, /SPG4/
!------------------------------------------------------------------------------------
!
      integer :: JR1,JRG,JR2,NI
      complex(8) :: DB(6,3,6,5)
!
      integer :: KKB(3),KBB(3),INDA(6,3),INDB(6,3),ICC,IBB,IND
      integer :: IR1(7,48),IR2(7,48),IRG(7,48)
      complex(8) :: CW
      complex(8) :: WWD1(48,6),WWD2(48,6),WWDG(48,3)
      complex(8) :: wa(6,3),CR1(48),CR2(48),CRG(48)
      real(8) :: WC
      integer :: JGG(48),JGK(48)
      integer :: NTAB(48)
      integer :: NA,NBS
      integer :: NHG,NDG,IBS,ND1,ND2
      integer :: IDOUBB,IDB,NHK,NAS
      integer :: i,j,k,n, IB,NB,NNI
!
      do K=1,3
        KBB(K)=KB(K)
      enddo

      IBB=ICB
      IDOUBB=IDOUB

      do j=1,3
        KKB(j)=0
      enddo
      ICC=1

      !
      ! obtain small representaion (single group) at GM
      !
      CALL TSIREP(KKB,ICC,0)

      !
      ! check for Irreducible Representation
      !
      CALL CHKNIR(JRG,NR)

      NHG=NH
      NDG=ND(JRG)

      do J=1,NHG
          JGG(J)=JG(J)
          CRG(J)=CR(J,JRG)
          do K=1,7
            IRG(K,J)=IR(K,J,JRG)
          enddo
      enddo

      do K=1,3
        KKB(K)=KBB(K)
      enddo

      ICC=IBB
      IDB=IDOUBB
      CALL TSIREP(KKB,ICC,IDB)
      CALL CHKNIR(JR1,NR)
      NHK=NH
      ND1=ND(JR1)

      do J=1,NHK
        JGK(J)=JG(J)
        CR1(J)=CR(J,JR1)
        do K=1,7
          IR1(K,J)=IR(K,J,JR1)
        enddo
      enddo

      CALL CHKNIR(JR2,NR)
      ND2=ND(JR2)
      do J=1,NHK
        CR2(J)=CR(J,JR2)
        do K=1,7
          IR2(K,J)=IR(K,J,JR2)
        enddo
      enddo

      CALL SUBGRP(NHK,JGK,NHG,JGG,NTAB,IND)

      IF(IND.NE.0) then
        WRITE(6,*) ' K-POINT GROUP IS NOT A SUBGROUP'
        WRITE(6,*) ' STOP AT 99 IN DIRSEL'
        STOP
      endif

!
!   CHARACTER TEST
!
      CW=(0.0d0,0.0d0)
      do I=1,NHK
        CW =CW+ CONJG( CR1(I) ) * CR2(I) * CRG(NTAB(I))
      enddo
      CW=CW/NHK
      NI=real(CW)+0.5
      IF(NI.GT.5) THEN
         WRITE(6,*) ' Dimension of DB is not enough NI=',NI
         WRITE(6,*) ' Stop at 23 in Sub.DRCGCF '
         STOP
      END IF
      
      IF(NI.EQ.0) return

      do NA=1,ND2
        do NBS=1,NDG
          INDA(NA,NBS)=0
        enddo
      enddo

      DO 82 NNI=1,NI
      !==========================================================================================
      !
      !   Projection Operator
      !
      !     Pivot is set at the component of single representation which is not appered
      !   in the previous projection for the first component of duble representation
      !
        DO 83 IB=1,ND2
          DO 831 IBS=1,NDG
            IF(INDA(IB,IBS).EQ.1) cycle
            NB=IB
            NBS=IBS
            !---------------------------------------------------
            !  MATRIX ELEMENTS OF SINGLE REPRESENTATION
            CALL GETMXE(IR2,ND2,NHK,NB,WWD2)
            CALL GETMXE(IRG,NDG,NHG,NBS,WWDG)
            !----------------------------------------------------
            DO 84 N=1,ND1
              !----------------------------------------------------
              !  SECOND SUFFIX OF PROJECTION OPERATOR IS FIXED AT 1
              CALL GETMXE(IR1,ND1,NHK,1,WWD1)
              !-----------------------------------------------------

              do NA=1,ND2
                do NAS=1,NDG
                  WA(NA,NAS)=(0.0d0,0.0d0)
                  INDB(NA,NAS)=0
                enddo
              enddo

              do J=1,NHK
                  IF(ABS(WWD1(J,N)).GT.1.0D-7) THEN
                      do NA=1,ND2
                          IF(ABS(WWD2(J,NA)).ge.1.0D-7) then
                              do NAS=1,NDG
                                  IF(ABS(WWDG(NTAB(J),NAS)).ge.1.0D-7) then
                                      IF(N.EQ.1) INDB(NA,NAS)=1
                                      WA(NA,NAS)=WA(NA,NAS)+CONJG(WWD1(J,N))*WWD2(J,NA)*WWDG(NTAB(J),NAS)
                                  endif
                              enddo
                          endif
                      enddo
                  END IF
              enddo

              WC=0.0d0

              do  NA=1,ND2
                do  NAS=1,NDG
                 WC=WC+real( CONJG(WA(NA,NAS)) * WA(NA,NAS) )
                enddo
              enddo
              
              IF(WC.LT.1.0D-5) THEN
                   IF(N.EQ.1) then
                       GO TO 831
                   else
                       WRITE(6,*) ' THIS CAN NOT BE HAPPEN '
                       WRITE(6,*) ' STOP AT 36 IN DIRSEL '
                       STOP
                   endif
              END IF
              
              do NA=1,ND2
                do NAS=1,NDG
                  IF(INDB(NA,NAS).EQ.1) INDA(NA,NAS)=1
                 enddo
              enddo

              WC=DSQRT(WC)

              do NA=1,ND2
                do NAS=1,NDG
                  DB(N,NAS,NA,NNI)=WA(NA,NAS)/WC
                  IF(ABS(AIMAG(DB(N,NAS,NA,NNI))).LT.1.0D-7) THEN
                      DB(N,NAS,NA,NNI)=CMPLX(DBLE(DB(N,NAS,NA,NNI)),0.0D0)
                  END IF
                  IF(ABS(DBLE(DB(N,NAS,NA,NNI))).LT.1.0D-7) THEN
                      DB(N,NAS,NA,NNI)=CMPLX(0.0D0,AIMAG(DB(N,NAS,NA,NNI)))
                  END IF
                enddo
              enddo
   84       CONTINUE
            GO TO 82
  831     CONTINUE
   83   CONTINUE
        WRITE(6,*) ' PIVOT SET ALGORISM IS NOT ENUGH '
        WRITE(6,*) ' STOP AT 83 IN DIRSEL '
        STOP
   82 CONTINUE
      RETURN
      END
