! SUBROUTINE INTPOR ====*====3====*====4====*====5====*====6====*====7
!
! -- input --
!   Iaxis       : Index of axis
!   KBB(3) / IC : Reciprocal Lattice
!   IR          : Index of Irreducible Representation
!
!   IUD = 2 ... NSPIN = 2 ( Magnetic Calculation, Down Spin )
!       = 1 ... other
!
! -----------------------------------------------------------------
!
! modified by H.Funashima,2010
!   remove argument JD and NH ( not use.)
!
!---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      SUBROUTINE INTPOR(Iaxis,KBB,ICC,IR,IUD)
      use ayband_param, only:maxeig,maxfkp,n65
      use scl, only:ipr
      use spgspl
      use axe, only:eax,nlin,jrr,naxen
      use axe, only:nlin,jrr,naxen
      use axp, only:ifkp,kkb,iccb,icptbl,npoint
      use isp, only:ix,icon,naxm
      use kkend
      use enr, only:iudm,mrnm,neigm,eigm
      use mrk
      implicit none
!
      integer :: Iaxis,KBB(3),ICC,IR,IUD
!
      character(2) :: MRR
      integer :: IRNM(maxeig,maxfkp),J00LR(maxeig,2)
      real(8) :: XX(n65),YY(n65),X(maxfkp),YM(maxeig,maxfkp)
      real(8) :: SM(maxfkp)
      integer :: JMAX(maxfkp)
      integer :: IXM(maxfkp)
      real(8) :: Y(maxfkp),XXI(maxfkp)
      integer :: NL(maxeig),NR(maxeig)
      real(8) :: wide,DD,D6,XI
      integer :: ICO,INIT,NNN,J1,nxi
      integer :: JL,JR,JJMAX
      integer :: i,j,jj,k,L,NI
!
! boundary condition for S3N
!
      real(8) :: C1,CN,AMU1,ALMN
!
      D6=1.0D-6

      IF(IPR.GE.2) THEN
          CALL KPNAME(KBB(1),KBB(2),KBB(3),ICC,MRR)
          WRITE(6,600) MRR,IR
  600     FORMAT(' INTERPORATION START FOR ',A2,I2)
      END IF

      JRR(NAXEN)=Iaxis
      WIDE=DBLE(KKM(2,IX(Iaxis),Iaxis))/ICCM(2,Iaxis)  -  DBLE(KKM(1,IX(Iaxis),Iaxis))/ICCM(1,Iaxis)
      NXI=0
      
      DO 1 I=1,NPOINT
         IF(IUD.NE.IUDM(IFKP(I))) cycle
         
         XI=( DBLE(KKB(IX(Iaxis),I))/ICCB(I)  -  DBLE(KKM(1,IX(Iaxis),Iaxis))/ICCM(1,Iaxis))/WIDE
         IF( (IR.eq.1) .and. (XI+D6.ge.0.0d0) .and. (XI-D6 .le. 1.0D0) ) then
               IF(XI+D6.LT.1.0D0.OR.Iaxis.EQ.NAXM.OR.ICON(Iaxis).EQ.1) THEN
                   NSIT(IFKP(I))=NSIT(IFKP(I))+1
                   IF(NSIT(IFKP(I)).GT.3) THEN
                       WRITE(6,*) ' NSIT MUST BE LESS THAN 3',NSIT(IFKP(I))
                       STOP
                   END IF 
                   MSIT(NSIT(IFKP(I)),IFKP(I))=Iaxis
                   XIMS(NSIT(IFKP(I)),IFKP(I))=XI
               END IF
         endif

         IF(ICPTBL(IR,I).EQ.0) cycle

         IF(NXI.ne.0) then
             do NI=1,NXI
               IF(DABS(XI-X(NI)).LT.1.0D-6) GO TO 12
             enddo
         endif
         NXI=NXI+1
         JMAX(NXI)=0
         X(NXI)=XI
         NI=NXI
   12    CONTINUE

         DO 5 L=1,NEIGM(IFKP(I))
               DO 2 K=1,ICPTBL(IR,I)
                  if(JMAX(NI).ne.0) then
                      do JJ=1,JMAX(NI)
                         J1=JMAX(NI)-JJ+1
                         IF(YM(J1,NI).LT.EIGM(L,IFKP(I))) GO TO 53
                         YM(J1+1,NI)=YM(J1,NI)
                         IRNM(J1+1,NI)=IRNM(J1,NI)
                      enddo
                  endif
                  J1=0
   53             YM(J1+1,NI)=EIGM(L,IFKP(I))
                  IRNM(J1+1,NI)=MRNM(IFKP(I))
                  JMAX(NI)=JMAX(NI)+1
    2          CONTINUE
    5    CONTINUE

    1 CONTINUE




      do I=1,NXI
        IXM(I)=I
      enddo

      XXI(1)=X(1)

      DO 61 I=2,NXI
         DO 62 J=1,I-1
            JJ=I-J
            IF(XXI(JJ).LT.X(I)) GO TO 63
            XXI(JJ+1)=XXI(JJ)
            IXM(JJ+1)=IXM(JJ)
   62    CONTINUE
         JJ=0
   63    JJ=JJ+1
         XXI(JJ)=X(I)
         IXM(JJ)=I
   61 CONTINUE
      CALL CHGORD(XXI,IXM,NXI,YM,JMAX,JL,NL,JR,NR)

      NLIN(NAXEN)=0
!      NKPT(NAXEN)=N65
      JJMAX=0
      

      !
      ! find maximum of jmax
      !

      do I=1,NXI
         IF(JMAX(I).GT.JJMAX) JJMAX=JMAX(I)
      enddo

      CALL ENDTRM(Iaxis,XXI,IXM,NXI,IRNM,JMAX,JJMAX,J00LR)
      DO 70 J=1,JJMAX 
         !
         ! NNN: data point in axis
         !
         NNN=0

         do I=1,NXI
            IF(JMAX(IXM(I)).LT.J) then
                cycle
            else
                IF(XXI(I).LT.0.0D0) THEN
                   if( (J00LR(J,1).ne.0)  .and. (J00LR(J,1).ne.9) ) then
                       NNN=NNN+1
                       X(NNN)=XXI(I)
                       IF(JL.EQ.1) THEN
                         Y(NNN)=YM(NL(J),IXM(I))
                       ELSE
                         Y(NNN)=YM(J,IXM(I))
                       END IF
                   endif
                ELSE IF(XXI(I).GT.1.0D0) THEN
                   if( (J00LR(J,2).ne.0) .and. (J00LR(J,2).ne.9) ) then
                       NNN=NNN+1
                       X(NNN)=XXI(I)
                       IF(JR.EQ.1) THEN
                           Y(NNN)=YM(NR(J),IXM(I))
                       ELSE
                           Y(NNN)=YM(J,IXM(I))
                       END IF
                   endif
                ELSE
                    NNN=NNN+1
                    X(NNN)=XXI(I)
                    Y(NNN)=YM(J,IXM(I))
                END IF
            endif
         enddo

         IF(NNN.ge.3) then
         !
         ! cubic spline needs more than 3 sampling point...
         !
         !
             IF(IPR.GE.4) THEN
                 WRITE(6,*) ' BAND NO=',J
                 WRITE(6,666) (X(I),I=1,NNN)
                 WRITE(6,666) (Y(I),I=1,NNN)
  666            FORMAT(10F7.4)
             END IF

             IF(J00LR(J,1).NE.0) THEN
                C1=4.0*((Y(2)-Y(1))/(X(2)-X(1)))
                AMU1=2.0D0
             ELSE
                C1=0.0D0
                AMU1=0.0D0
             END IF

             IF(J00LR(J,2).NE.0) THEN
                CN=4.0*((Y(NNN)-Y(NNN-1))/(X(NNN)-X(NNN-1)))
                ALMN=2.0D0
             ELSE
                CN=0.0D0
                ALMN=0.0D0
             END IF
        
             INIT=0
             ICO=0

             do I=1,N65
                DD=DBLE(I-1)/(N65-1)
                IF(DD.LT.X(1)) then
                    cycle
                else if(DD.GT.X(NNN)) then
                    exit
                else
                   IF(INIT.EQ.0) INIT=I
                   ICO=ICO+1
                   XX(ICO)=DD
               endif
             enddo

             IF(ICO.gt.3) then
               NLIN(NAXEN)=J
               CALL S3N(X,Y,SM,XX,YY,NNN,ICO,C1,CN,AMU1,ALMN)
               do I=1,N65
                 EAX(I,J,NAXEN)=99.0
               enddo
               do I=1,ICO
                  EAX(INIT+I-1,J,NAXEN)=YY(I)
               enddo
             endif
         endif 
   70 CONTINUE
      RETURN
      END
