! SUBROUTINE PLOTR  ====*====3====*====4====*====5====*====6====*====7
!
! PLOT FRAMES AND SCALES                                               *
!
!---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      SUBROUTINE PLOTR
      use isp, only:ps,icon,mk,naxm
      use jmpax
      use kkend
      use scl, only:wx,wy,EO,EM,YM,ipr
      use ayplot2, only:awrite,fwrite,lineto,moveto,setdas
      implicit none

!
      real(8) ::  X,Y,XO,XE,E
      real(8) ::  ESDV,E0A,EMA

      integer ::  KX(2,3),IC(2),ind(2)
      integer ::  I0,IM,JM,Iaxis
      character(2) :: MMM
      integer ::  j,ktype,N,I
!
      WRITE(6,'("NUMBER OF AXIS=",I3)') NAXM
      WRITE(6,*)
      XO=0.0d0


      do N=1,NAXM
        IF(IPR.GE.3) then 
            WRITE(6,1000) N,PS(1,N),PS(2,N),ICON(N)
 1000       FORMAT('AXIS No.=',I3,4X,'width:( X=',F10.6,' --> X=',F10.6,')',3X,'ICON=',I2)
        endif
        IF(ICON(N).EQ.1.OR.N.EQ.NAXM) THEN
           XE=WX*PS(2,N)
           CALL MOVETO(XO,0.0d0)
           CALL LINETO(XE,0.0d0)
           CALL MOVETO(XE,YM)
           CALL LINETO(XO,YM)
           !
           ! bug fixed 2011 ( intel Fotran check )
           !  by H.Funashima. PS(1,N+1) is undifined.
           !
           !XO=WX*PS(1,N+1)
           XO=WX*PS(1,N)
        ENDIF
      enddo


      do N=1,NAXM
        IF( ICON(N).EQ.1  .OR.  N.EQ.NAXM) then
            JM=2
        else
            JM=1
        endif
        do J=1,JM
          X=PS(J,N)*WX
          CALL MOVETO(X,0.0d0)
          CALL LINETO(X,YM)
        enddo
        !---------------------------------------------------------
        !
        ! for JOPT is active.
        !
        !
        !
        IF(JOPT.ne.0) then
            do ktype=1,2
              do j=1,3
                KX(ktype,j)=KKM(ktype,j,N)
              enddo
              IC(ktype)=ICCM(ktype,N)
              CALL TSKFBZ(KX(ktype,1),KX(ktype,2),KX(ktype,3),IC(ktype),IND(ktype))
            enddo
            !
            ! bug fixed by H.Funashima,2011
            !  using Intel Fortran Compiler Check.
            !
            Iaxis=N
            IF((IND(1).EQ.0.AND.IND(2).NE.0).OR.(IND(2).EQ.0.AND.IND(1).NE.0)) THEN
                !Iaxis=N
                CALL AXJUMP(Iaxis,IND)
                IF(INDJAX(Iaxis).EQ.1) THEN
                    X=(PS(1,N)+RTJMP(N))*WX
                    CALL SETDAS(6,4,1)
                    CALL MOVETO(X,0.0d0)
                    CALL LINETO(X,YM)
                    CALL SETDAS(0,0,0)
                END IF
            ELSE 
                INDJAX(Iaxis)=0
            END IF
        ENDIF
        !---------------------------------------------------------
      enddo
 

      CALL MOVETO(-7.0d0,0.0d0)
      CALL LINETO(-10.0d0,0.0d0)
      CALL LINETO(-10.0d0,YM)
      CALL LINETO(-7.0d0,YM)
      ESDV=0.1d0
      IF(EM-EO.GT.10.0d0) ESDV=2.0d0
      IF(EM-EO.LT.5.0d0) ESDV=0.2d0
      IF(EM-EO.LT.2.0d0) ESDV=0.1d0
      IF(EM-EO.LT.0.2d0) ESDV=0.01d0
      IF(EM-EO.LT.0.05d0) ESDV=0.002d0
      IF(EM-EO.LT.0.02d0) ESDV=0.001d0
      E0A=(EO-0.00001d0)/ESDV
      IF(E0A.GE.0.0d0) I0=INT(E0A)+1
      IF(E0A.LT.0.0d0) I0=INT(E0A)
      EMA=(EM+0.00001d0)/ESDV
      IF(EMA.GE.0.0d0) IM=INT(EMA)
      IF(EMA.LT.0.0d0) IM=INT(EMA)-1
      write(6,2000)EM-EO,ESDV
2000  format('Energy Width = ',f6.3,' EnergyScale=',f6.3)


      do I=1,IM-I0+1
        E=(I0+I-1)*ESDV
        Y=(E-EO)*WY
        if(  (ABS(Y).ge.1.0) .and. (ABS(Y-YM).ge.1.0) ) then
          CALL MOVETO(-10.0d0,Y)
          CALL LINETO(-7.0d0,Y)
        endif
        IF(ESDV.GE.0.1) then
            CALL FWRITE(18,E,4,1,-13.0d0,Y-4.5d0,90)
        else
            CALL FWRITE(18,E,4,2,-13.0d0,Y-4.5d0,90)
        endif
      enddo

      CALL AWRITE(20,'Energy (Ry)',11,-25.0d0,YM/2.0d0,90)

      do N=1,NAXM
        MMM=MK(1,N)
        X=WX*PS(1,N)
        CALL CTYPE(X,-10.0d0,20,MMM)
        MMM=MK(2,N)
        X=WX*(PS(1,N)+PS(2,N))/2.0
        CALL CTYPE(X,-7.5d0,18,MMM)
        IF(ICON(N).EQ.1.OR.N.EQ.NAXM) THEN
            MMM=MK(3,N)
            X=WX*PS(2,N)
            CALL CTYPE(X,-10.0d0,20,MMM)
        ENDIF
      enddo

      RETURN
      END
