! SUBROUTINE STRUCT ====*====3====*====4====*====5====*====6====*====7
!
! SELECTION OF POINTS TO BE PLOTTED                                    *
!
!---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      SUBROUTINE STRUCT(jf,NLCOMP,NSPIN,JMARK)
      use scl
      use isp
      use jmpax
      use kkend
      use canvas
      implicit none
!
      integer :: NLCOMP,NSPIN,JMARK
!
      integer       ::  KK1(3),KK2(3),KK3(3),KTV(3),KG(3)
      integer       ::  icc1,icc2,icc3
      integer       ::  kx(3),icc
      character(4)  ::  CHARA4
      character(10) ::  MAGNET
      real(8) :: ww,BLK
      integer :: NK,ind,jf
      integer :: i,j,iix, Iaxis
!
      rewind jf
!
      READ(jf,150) MAGNET
 150  format(A10)
      CHARA4=MAGNET
      select case(CHARA4)
        case('NONM')  ; ISO=1
        case('MAGN')  ; ISO=2
        case('SPIN')  ; ISO=3
        case default
            write(6,*) 'Unknow type. stop in sub struct'
            stop
      end select 
!
      READ(jf,*) NLCOMP,NSPIN,IFILE
      IF((ISO.EQ.1.OR.ISO.EQ.3).AND.NSPIN.NE.0) THEN
         write(6,*) '============================= WARNING ==========================='
         WRITE(6,*) ' FOR PARAMAGNETIC BANDS NSPIN MUST BE 0',NSPIN
         write(6,*) ' NSPIN:',NSPIN,' -->  0'
         NSPIN=0
         write(6,*) '=================================================================='
      END IF
      IF(ISO.EQ.2.AND.(NSPIN.LE.0.OR.NSPIN.GT.3)) THEN
         WRITE(6,*) ' FOR FERROMAGNETIC BANDS'
         WRITE(6,*) ' NSPIN=1 ONLY FOR UP   SPIN BANDS'
         WRITE(6,*) ' NSPIN=2 ONLY FOR DOWN SPIN BANDS'
         WRITE(6,*) ' NSPIN=3 FOR BOTH SPIN BANDS'
         STOP
      END IF
      if ( NKA .ne. NLCOMP ) then
         write(6,*) '============================= WARNING ==========================='
         write(6,*) ' CONFLICT CRYSTAL DATA FILE.'
         write(6,'(3x,"NLCOMP MUST BE ",i3,", BUT INPUT NLCOMP =",i3)')nka,nlcomp
         write(6,'(3x,"NLCOMP: ",i3,"-->",i3)')nlcomp,nka
         write(6,*) '=================================================================='
         nlcomp = nka
      endif

      READ(jf,*) IPR,JMARK,IPOINT,JOPT
      READ(jf,*) EO,EM,YM,XM
      WY=YM/(EM-EO)
!
      READ(jf,*) NAXM
!
      call set_allocate_isp
      call set_allocate_jmpax
      call set_allocate_kkend
!
      PS(1,1)=0.0d0
      NK=0
!
      do i=1,3
        KK3(i)=i
      enddo
      ICC3=9999999

      DO 99 Iaxis=1,NAXM
          !=====================================================================
          !
          ! read to be ploted axis data. from fort.3
          !
          !   KK1(3)/ICC1  ... starting point 
          !   KK2(3)/ICC2  ... end point 
          !
          !
          !
          READ(jf,*) (KK1(J),J=1,3),ICC1,(KK2(J),J=1,3),ICC2
          !
          ! --- output axis data, if you need. ---
          !
          !
          if (IPR.GE.2) then
              WRITE(6,710) Iaxis
  710         FORMAT('AXIS No.=',I3)
              WRITE(6,600) (KK1(J),J=1,3),ICC1,(KK2(J),J=1,3),ICC2
  600         FORMAT( 2x,'(',3I4,')/',I4,'--->','(',3I4,')/',I4)
          endif
          !
          !-----------------------------------------------------------
          !
          ! check: wether kk1 and kk2 is same k-point or not?
          do J=1,3
            IIX=J
            IF(KK1(J)*ICC2.NE.KK2(J)*ICC1) then
                exit !Escape J-loop
            endif
            if(j.eq.3) then
              write(6,*)  'KK1 AND KK2 ARE THE SAME POINT'
              stop
            endif
          enddo
          !
          !
          !=====================================================================

          IX(Iaxis)=IIX

          !--------------------------------------------------------------
          !
          ! In Iaxis' th axis, 
          !    KK1(3)/ICC1 : starting point
          !    KK2(3)/ICC2 : end point
          !
          !    KTV(3)/ICC  : relative vector KK2(3)/ICC2 from KK1(3)/ICC1
          !
          !--------------------------------------------------------------
          do J=1,3
            KKM(1,J,Iaxis)=KK1(J)
            KKM(2,J,Iaxis)=KK2(J)
            KTV(j)=KK2(j)*ICC1-KK1(j)*ICC2
          enddo
          ICCM(1,Iaxis)=ICC1
          ICCM(2,Iaxis)=ICC2
          ICC=ICC1*ICC2

          !----------------------------------------------------------------
          !
          ! == Specification Entry ZZZY37(in TSPACE) ==
          !
          ! call zzzy37(kx,ky,kz,s)
          !
          ! -- input --
          !   kx,ky,kz,ic : coordinate (kx,ky,kz) /ic ( ic is common denominator )
          !
          ! -- output --   
          !   s: norm of reciprocal vector
          !
          CALL ZZZY37(KTV(1),KTV(2),KTV(3),ICC,WW)
          !  
          !----------------------------------------------------------------
          !
          ! store Length of Iaxis' th axis as RT(Iaxis)  in module scl
          !
          RT(Iaxis)=WW
          !
          !----------------------------------------------------------------

          BLK=0.0d0
          ICON(Iaxis)=0
          IF(Iaxis.NE.1) THEN
                !----------------------------------------------------------------
                !
                ! == Specification Subroutine EQUIKK(in TSPACE) ==
                !
                ! call EQUIKK(kk1,icc1,kk3,icc3,KB,IND)
                !
                ! -- normal equivalency ---
                !
                !    If KK1(3)/IC is equivalent to KK3(3)/ICC3 then
                !       KG(K)=KBB(K)/ICC-KS(K,IS)/ICBB
                !       IND=JS(IS) :Operation code translating KS(K,IS) from KK1/ICC1
                !       Where KS(K,IS)/ICBB is one of the star of KK1(K)/ICC1
                !
                ! -- time reversal equivalency ---
                !
                !    Else if KB(3)/IC is equivalent to -KBB(3)/ICC then
                !       KG(K)=-KBB(K)/ICC-KS(K,IS)/ICBB
                !       IND=-JS(IS) :Operation code translating KS(K,IS) from KK1/ICC1
                !       Where KS(K,IS)/ICBB is one of the star of KK1(K)/ICC1
                !
                !    ELSE
                !       KG(K)=999, IND=0
                !
                CALL EQUIKK(KK1,ICC1,KK3,ICC3,KG,IND)
                !
                !----------------------------------------------------------------

                IF(IND.EQ.0) THEN
                    ICON(Iaxis-1)=1
                    BLK=0.3d0*ABS(RT(1))
                ENDIF
                PS(1,Iaxis)=PS(2,Iaxis-1)+BLK
          ENDIF
          PS(2,Iaxis)=RT(Iaxis)+PS(1,Iaxis)
          
          IF(IPR.GE.2) then
              WRITE(6,601) RT(Iaxis)
  601     FORMAT(2x,'Length=',F10.5)
          endif

          do J=1,3
            KK3(J)=KK2(J)
          enddo
          ICC3=ICC2
          
          !============================================================
          !
          ! store in KM(itype,Iaxis)
          !    ityle = 1 ... starting point of axis
          !          = 2 ... middle   point of axis
          !          = 3 ... end point of axis
          !    Iaxis: Index of Axis
          !
          !
          !--------------------------------------------------------
          
          !---------------------------------------------------
          !
          ! == starting point in axis ===
          !
          ! store in KPNAME( KK1(3) / ICC1 )  as MK(1,Iaxis) in module isp 
          !
          CALL KPNAME(KK1(1),KK1(2),KK1(3),ICC1,MK(1,Iaxis))
          !
          !---------------------------------------------------

          !---------------------------------------------------
          !
          ! == end point in axis===
          !
          ! store in KPNAME( KK2(3) / ICC2 )  as MK(3,Iaxis) in module isp 
          !
          CALL KPNAME(KK2(1),KK2(2),KK2(3),ICC2,MK(3,Iaxis))
          !
          !---------------------------------------------------

           
          !---------------------------------------------------
          !
          ! == middle point in axis===
          !
          !  KX(3)/ICC is middle point of KK1/ICC1 and KK2/ICC2
          !
          do j=1,3
            KX(j)=KK1(j)*ICC2+KK2(j)*ICC1
          enddo
          ICC=ICC1*ICC2*2
          !
          ! store in KPNAME( KX(3) / ICC )  as MK(2,Iaxis) in module isp
          !
          CALL KPNAME(KX(1),KX(2),KX(3),ICC,MK(2,Iaxis))
          !
          !---------------------------------------------------
          !
          ! output infomation, if you need.
          !

          IF(IPR.GE.2) THEN
            WRITE(6,602) (MK(j,Iaxis),j=1,3)
            WRITE(6,*)
          END IF
          !
          !
          !============================================================

  602     FORMAT(2x,'K-point Name: ',A2,'(:axis start) -->',1x,A2,'(middle point) -->',1x,A2'(axis end)')
   99 CONTINUE
      WX=XM/PS(2,NAXM)
      RETURN
      END
